#ifndef RL_API_H_
#define RL_API_H_

#include <time.h>
#include <stddef.h>
#include <stdint.h>

#ifdef _WIN32
	#ifdef RL_COMPILING_DLL
		#define RL_API __declspec(dllexport)
	#else
		#define RL_API __declspec(dllimport)
	#endif
#elif defined(__GNUC__) || defined(__clang__) 
	#define RL_API __attribute__((visibility("default")))
#else
	#define RL_API
#endif
#ifdef __cplusplus
	#define RL_C_API extern "C" RL_API
#else
	#define RL_C_API extern RL_API
#endif

RL_C_API const uint32_t rlMaxHostnameLen;
RL_C_API const uint32_t rlMaxFilenameLen;
RL_C_API const uint32_t rlMaxTextLen;
RL_C_API const uint32_t rlMaxListDocumentLen;

RL_C_API void rlGetLastError( char* buffer, int32_t bufferSize );
RL_C_API int32_t rlGetLastErrorLen( void );

#endif